<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionDocumento }}</strong>
    </div>
    <!--Contenido-->
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">{{ textoGestionDocumento }}</div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <br />
      <template v-if="folio.idFolio">
        <v-stepper v-model="folio.indicePaso" :alt-labels="true" non-linear>
          <v-stepper-header>
            <template v-for="(itemStep, indexItemStep) in steps">
              <v-stepper-step
                :editable="itemStep.isStepInvalid"
                :key="`${indexItemStep}-step`"
                :complete="false"
                :step="itemStep.no"
                :rules="[() => !itemStep.isStepInvalid]"
              >
                <span :class="[{ 'error--text': itemStep.isStepInvalid }]">
                  {{ itemStep.name }}
                </span>
              </v-stepper-step>
              <div
                class="v-divider progress"
                :key="indexItemStep"
                v-if="indexItemStep !== steps.length - 1"
              >
                <v-progress-linear
                  :value="getProgressBar(indexItemStep)"
                  :color="!itemStep.isStepInvalid ? 'primary' : 'error'"
                  height="10"
                  reactive
                  striped
                ></v-progress-linear>
              </div>
            </template>
          </v-stepper-header>
          <v-stepper-items>
            <v-stepper-content
              v-for="(itemStep, indexItemStep) in steps"
              :key="indexItemStep + '-content'"
              :step="itemStep.no"
            >
              <div style="min-height: 540px">
                <template v-if="itemStep.no === 1">
                  <Documento
                    :ref="'stepper-content-' + indexItemStep"
                    :folio="folio"
                    @loaded="loadedComponent"
                  />
                </template>
                <template v-if="itemStep.no === 2">
                  <Rutas
                    :ref="'stepper-content-' + indexItemStep"
                    :folio="folio"
                    @loaded="loadedComponent"
                  />
                </template>
                <template v-if="itemStep.no === 3">
                  <Firmas
                    :ref="'stepper-content-' + indexItemStep"
                    :folio="folio"
                    @loaded="loadedComponent"
                  />
                </template>
                <template v-if="itemStep.no === 4">
                  <Resumen
                    :ref="'stepper-content-' + indexItemStep"
                    :folio="folio"
                  />
                </template>
              </div>
            </v-stepper-content>
          </v-stepper-items>
        </v-stepper>
      </template>
      <div class="btnCenter">
        <div class="btnCenter ma-0">
          <v-btn
            v-if="folio.indicePaso != 1"
            class="mr-6"
            depressed
            dark
            tile
            color="secundary"
            @click="previewStep"
            >Regresar</v-btn
          >
          <v-btn
            v-if="folio.indicePaso == 1"
            :class="[{ desac: !(folio.indicePaso != 1) }]"
            class="mr-6"
            depressed
            dark
            tile
            color="secundary"
            >Cancelar</v-btn
          >
          <v-btn
            v-if="folio.indicePaso < steps.length"
            :class="[{ desac: folio.indicePaso === steps.length }]"
            class="mr-6"
            depressed
            dark
            tile
            color="primary"
            @click="nextStep"
            >Continuar</v-btn
          >
          <template v-if="folioEdit">
            <v-btn
              v-if="folio.indicePaso == steps.length || folioEdit"
              class="mr-6"
              tile
              color="white"
              :to="{ name: 'modelo_negocio_documentos_estados' }"
              >Regresar a documentos</v-btn
            >
            <v-btn
              v-if="folio.indicePaso == steps.length"
              depressed
              dark
              tile
              color="primary"
              @click="putFolioEstados(3)"
              >Enviar a revisión</v-btn
            >
          </template>
          <template v-else>
            <v-btn
              v-if="folio.indicePaso == steps.length"
              class="mr-6"
              tile
              color="white"
              @click="putFolioEstados(2)"
              >Crear documento</v-btn
            >
            <v-btn
              v-if="folio.indicePaso == steps.length"
              depressed
              dark
              tile
              color="primary"
              @click="putFolioEstados(3)"
              >Crear documento y enviar a revisión</v-btn
            >
          </template>
        </div>
      </div>
    </div>
    <template>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tienes algunos conflictos de validación
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que corregirlos para
            moverte entre un paso y otro.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogDocumento" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong v-if="folio.estado.idEstadoFolio == 2"
                >El documento ha sido creado</strong
              >
              <strong v-else
                >El documento ha sido creado y enviado a revisión</strong
              >
              <v-btn
                color="secondary"
                icon
                dark
                @click="$router.go($router.currentRoute)"
                style="position: absolute; right: 0px; top: 0px"
              >
                <v-icon>mdi-close</v-icon>
              </v-btn>
            </div>
          </v-card-title>
          <v-card-text>
            <span
              >Creación del documento con
              <strong>Folio {{ folio.idFolio }}</strong>
            </span>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                :to="{ name: 'modelo_negocio_documentos_estados' }"
                >Estatus del documento</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<style scoped>
.v-divider.progress {
  border: none;
}
</style>
<script>
import store from "@/store";
import Documento from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/documentos/Documento.vue";
import Rutas from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/Rutas.vue";
import Firmas from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/firmas/Firmas.vue";
import Resumen from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/resumen/Resumen.vue";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-GestionDocumento",
  components: {
    Documento,
    Rutas,
    Firmas,
    Resumen,
  },
  data() {
    return {
      dialogErrorValidation: false,
      dialogDocumento: false,
      dialogSave: false,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Negocio",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_negocio",
          },
        },
        {
          text: "Documento",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_negocio_documentos",
          },
        },
      ],
      steps: [
        {
          no: 1,
          name: "Documento",
          isStepInvalid: false,
        },
        {
          no: 2,
          name: "Rutas documento",
          isStepInvalid: false,
        },
        {
          no: 3,
          name: "Revisores/Autorizadores",
          isStepInvalid: false,
        },
        {
          no: 4,
          name: "Resumen",
          isStepInvalid: false,
        },
      ],
      stepInvalid: null,
      folio: {
        idFolio: null,
        estado: {
          idEstadoFolio: null,
        },
        numeroEmpleadoCreador: null,
        indicePaso: null,
        fechaCreacion: null,
        fechaModificacion: null,
      },
      folioEdit: null,
      textoGestionDocumento: null,
    };
  },
  validations: {
    steps: {
      $each: {
        isStepInvalid: {
          required: (value) => {
            return value !== null && !value;
          },
        },
      },
    },
  },
  watch: {
    dialogErrorValidation(val) {
      if (!val && this.stepInvalid) {
        //this.folio.indicePaso = this.stepInvalid;
      }
    },
    "folio.indicePaso": {
      deep: true,
      handler: function(val, prev) {
        if (val && val > 0) {
          this.putFolioIndicePaso();
          this.validateActiveStep(prev);
          let indexStepActive = this.getIndexStepByNo(prev);
          let stepActive = this.steps[indexStepActive];
        }
      },
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  methods: {
    loadedComponent() {
      if (this.folioEdit) {
        this.validateSteps();
      }
    },
    initValues() {
      if (this.folio.idFolio) {
        this.breadcrumbs.push({
          text: "Edición",
          disabled: true,
        });
        this.textoGestionDocumento = "Editando un Documento";
      } else {
        this.breadcrumbs.push({
          text: "Nuevo",
          disabled: true,
        });
        this.textoGestionDocumento = "Nuevo Documento";
      }
    },
    getFoliosUsuario() {
      let self = this;
      let empleado = user.empleado;
      axios("/modelo-negocio/folios/v1/usuarios/" + empleado)
        .then((response) => {
          let data = response.data;
          if (data) {
            self.folio = data.resultado;
          }
        })
        .catch((error) => {
          if (error.response) {
            if (error.response.status == 404) {
              this.nuevoFolio();
            }
          }
        });
    },
    getFolio(idFolio) {
      let self = this;
      axios("/modelo-negocio/folios/v1/" + idFolio)
        .then((response) => {
          let data = response.data;
          if (data) {
            let folio = data.resultado;
            folio.idFolio = idFolio;
            if (self.folioEdit && self.folioEdit.indicePaso) {
              folio.indicePaso = self.folioEdit.indicePaso;
            }
            self.folio = folio;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.error(error.response);
          }
        });
    },
    nuevoFolio() {
      const self = this;
      let body = {
        numeroEmpleadoCreador: user.empleado,
      };
      axios
        .post("/modelo-negocio/folios/v1/", body)
        .then((response) => {
          let data = response.data;
          if (data) {
            self.folio.idFolio = data.resultado.id;
            self.folio.indicePaso = 1;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    putFolioIndicePaso() {
      let body = {
        indicePaso: this.folio.indicePaso,
      };
      axios
        .put(
          "/modelo-negocio/folios/v1/" + this.folio.idFolio + "/indice-paso",
          body
        )
        .then((response) => {})
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    putFolioEstados(idEstadoFolio) {
      this.folio.estado.idEstadoFolio = idEstadoFolio;
      let body = {
        idEstadoFolio: this.folio.estado.idEstadoFolio,
      };
      const self = this;
      axios
        .put(
          "/modelo-negocio/folios/v1/" + this.folio.idFolio + "/estados",
          body
        )
        .then((response) => {
          self.dialogDocumento = true;
        })
        .catch((error) => {
          if (error.response) {
            self.folio.estado.idEstadoFolio = 1;
            console.log(error.response.data);
          }
        });
    },
    getIndexStepByNo(no) {
      let indexStepOut;
      this.steps.forEach((itemStep, indexItemStep) => {
        if (no == itemStep.no) {
          indexStepOut = indexItemStep;
        }
      });
      return indexStepOut;
    },
    previewStep() {
      if (this.folio.indicePaso === 1) {
        this.folio.indicePaso = 1;
      } else {
        this.folio.indicePaso = this.folio.indicePaso - 1;
      }
    },
    nextStep() {
      this.validateActiveStep(this.folio.indicePaso);
      let indexStepActive = this.getIndexStepByNo(this.folio.indicePaso);
      let stepActive = this.steps[indexStepActive];
      if (stepActive && !stepActive.isStepInvalid) {
        if (this.folio.indicePaso === this.steps.length) {
          this.folio.indicePaso = this.steps.length;
        } else {
          this.folio.indicePaso = this.folio.indicePaso + 1;
        }

        //Se agrega el mandar las firmas a insertar;
        if (stepActive.no == 3) {
          this.$refs["stepper-content-2"][0].insertaFirmas();
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    getProgressBar(indexItemStep) {
      if (indexItemStep >= 0 && this.folio.indicePaso > indexItemStep + 1) {
        return 100;
      } else {
        return 0;
      }
    },
    validateActiveStep(indicePaso) {
      this.steps = this.steps.map((itemStep, indexItemStep) => {
        if (indicePaso == itemStep.no) {
          if (
            this.$refs["stepper-content-" + indexItemStep] &&
            this.$refs["stepper-content-" + indexItemStep][0].$v
          ) {
            this.$refs["stepper-content-" + indexItemStep][0].$v.$touch();
            itemStep.isStepInvalid =
              this.$refs["stepper-content-" + indexItemStep][0].$v.$invalid;
          }
        }
        return itemStep;
      });
    },
    validateSteps() {
      this.steps = this.steps.map((itemStep, indexItemStep) => {
        if (
          this.$refs["stepper-content-" + indexItemStep] &&
          this.$refs["stepper-content-" + indexItemStep][0].$v
        ) {
          let component = this.$refs["stepper-content-" + indexItemStep][0];
          component.$v.$touch();
          itemStep.isStepInvalid = component.$v.$invalid;
        }
        return itemStep;
      });
    },
  },
  created() {
    if (this.$route.params.folio) {
      let folioTemp = this.serviceCommons.base64ToObject(
        this.$route.params.folio
      );
      this.folio.idFolio = folioTemp.idFolio;
      this.folio.indicePaso = folioTemp.indicePaso;
      this.folioEdit = JSON.parse(JSON.stringify(folioTemp));
      if (
        this.folioEdit &&
        this.folioEdit.indicePaso &&
        this.folioEdit.indicePaso == 2
      ) {
        this.steps = [
          {
            no: 2,
            name: "Rutas documento",
            isStepInvalid: false,
          },
        ];
      }
      this.getFolio(folioTemp.idFolio);
    } else {
      this.getFoliosUsuario();
    }
    this.initValues();
  },
};
</script>
